import latch.LatchSupport;

import com.sleepycat.je.DatabaseException;
import com.sleepycat.je.dbi.DatabaseImpl;
import com.sleepycat.je.dbi.DatabaseImpl.PreloadLSNTreeWalker.INEntry;
import com.sleepycat.je.tree.IN;
import com.sleepycat.je.tree.Node;


public privileged aspect DatabaseImplExtension {

	
	Object around(IN in) throws DatabaseException : 
		execution(Node DatabaseImpl.PreloadLSNTreeWalker.hook_fetchLSN(long, IN, INEntry)) && 
		args(long,in,INEntry){
		in.latch();
		try {
			return proceed(in);
		} finally {
			in.releaseLatch();
		}
		
	}
	
	
	/*
	 * Release the latch on the root IN.
	 */
	//Lck needed to make public
	public void DatabaseImpl.releaseRootIN(IN root) throws DatabaseException {

		root.releaseLatch();
	}
	
	after() : execution(* DatabaseImpl.preload(..)){
		assert LatchSupport.countLatchesHeld() == 0;

	}
}
