import com.sleepycat.je.Database;
import com.sleepycat.je.DatabaseException;
import com.sleepycat.je.dbi.CursorImpl;
import com.sleepycat.je.dbi.DbTree;
import com.sleepycat.je.txn.Locker;

public aspect DbTreeExtension {
	before(CursorImpl cursorImpl) throws DatabaseException :
		call(* CursorImpl.close()) && target(cursorImpl) &&
		(
			withincode(* DbTree.dbRename(..)) || 
			withincode(* DbTree.dbRemove(..)) ||
			withincode(* DbTree.lockNameLN(..))||
			withincode(* DbTree.truncate(..))||
			withincode(* DbTree.getDb(Locker, String, Database, boolean))||
			withincode(* DbTree.getDbName(..))||
			withincode(* DbTree.verify(..))
		){
		cursorImpl.releaseBIN();
	}
}
