package com.sleepycat.je.log;

import latch.Latch;
import latch.LatchSupport;

import com.sleepycat.je.DatabaseException;
import com.sleepycat.je.dbi.EnvironmentImpl;

public aspect FileHandleExtension {

	// protected not allowed -> needed to make public
	public Latch FileHandle.fileLatch;

	after(FileHandle dt, String name, EnvironmentImpl env) : 
		execution(FileHandle.new(..)) && this(dt) && args(*,name, env,*) {
		dt.fileLatch = LatchSupport.makeLatch(name + "_fileHandle", env);
	}

	after(FileHandle dt) throws DatabaseException : 
		execution(void FileHandle.release()) && this(dt) {
		dt.fileLatch.release();
	}

	void FileHandle.latch() throws DatabaseException {

		fileLatch.acquire();
	}

	boolean FileHandle.latchNoWait() throws DatabaseException {

		return fileLatch.acquireNoWait();
	}

}
