package com.sleepycat.je.utilint;
import latch.Latch;
import latch.LatchSupport;

import com.sleepycat.je.DatabaseException;
import com.sleepycat.je.dbi.EnvironmentImpl;
import com.sleepycat.je.utilint.DaemonThread;

public aspect DaemonThreadExtension {

	// protected not allowed -> needed to make public
	public Latch DaemonThread.workQueueLatch;

	after(DaemonThread dt, String name, EnvironmentImpl env) : 
		execution(DaemonThread.new(long, String, EnvironmentImpl)) && this(dt) && args(long,name, env) {
		dt.workQueueLatch = LatchSupport.makeLatch(name + " work queue", env);
	}

	Object around(DaemonThread dt) throws DatabaseException :
		target(dt)&&
		(execution(void DaemonThread.addToQueue(Object)) ||
		execution(int DaemonThread.getQueueSize())) && within(DaemonThread) 
	{
		dt.workQueueLatch.acquire();
		Object r = proceed(dt);
		dt.workQueueLatch.release();
		return r;
	}
}
